"""IDAC Battle Gift and Tips added

Revision ID: e4e8d89c9b02
Revises: 81e44dd6047a
Create Date: 2024-04-01 17:49:50.009718

"""

from alembic import op
import sqlalchemy as sa
from sqlalchemy.dialects import mysql

# revision identifiers, used by Alembic.
revision = "e4e8d89c9b02"
down_revision = "81e44dd6047a"
branch_labels = None
depends_on = None


def upgrade():
    op.create_table(
        "idac_user_battle_gift",
        sa.Column("id", sa.Integer(), nullable=False),
        sa.Column("user", sa.Integer(), nullable=False),
        sa.Column("battle_gift_event_id", sa.Integer(), nullable=True),
        sa.Column("gift_id", sa.Integer(), nullable=True),
        sa.Column("gift_status", sa.Integer(), nullable=True),
        sa.Column(
            "received_date",
            sa.TIMESTAMP(),
            server_default=sa.text("now()"),
            nullable=True,
        ),
        sa.ForeignKeyConstraint(
            ["user"], ["aime_user.id"], onupdate="cascade", ondelete="cascade"
        ),
        sa.PrimaryKeyConstraint("id"),
        sa.UniqueConstraint(
            "user", "battle_gift_event_id", "gift_id", name="idac_user_battle_gift_uk"
        ),
        mysql_charset="utf8mb4",
    )

    op.create_table(
        "idac_profile_tips",
        sa.Column("id", sa.Integer(), nullable=False),
        sa.Column("user", sa.Integer(), nullable=False),
        sa.Column("version", sa.Integer(), nullable=False),
        sa.Column(
            "tips_list",
            sa.String(length=16),
            server_default="QAAAAAAAAAAAAAAA",
            nullable=True,
        ),
        sa.Column(
            "timetrial_play_count", sa.Integer(), server_default="0", nullable=True
        ),
        sa.Column("story_play_count", sa.Integer(), server_default="0", nullable=True),
        sa.Column(
            "store_battle_play_count", sa.Integer(), server_default="0", nullable=True
        ),
        sa.Column(
            "online_battle_play_count", sa.Integer(), server_default="0", nullable=True
        ),
        sa.Column(
            "special_play_count", sa.Integer(), server_default="0", nullable=True
        ),
        sa.Column(
            "challenge_play_count", sa.Integer(), server_default="0", nullable=True
        ),
        sa.Column("theory_play_count", sa.Integer(), server_default="0", nullable=True),
        sa.ForeignKeyConstraint(
            ["user"], ["aime_user.id"], onupdate="cascade", ondelete="cascade"
        ),
        sa.PrimaryKeyConstraint("id"),
        sa.UniqueConstraint("user", "version", name="idac_profile_tips_uk"),
        mysql_charset="utf8mb4",
    )


def downgrade():
    op.drop_table("idac_user_battle_gift")
    op.drop_table("idac_profile_tips")
